// Copyright (c) 2003-2010 Christopher M. Kohlhoff
// Modifications (c) 2011 by Guilherme Maciel Ferreira / Intra2net AG
//
// Distributed under the Boost Software License, Version 1.0.
//    (See accompanying file LICENSE_1_0.txt or copy at
//          http://www.boost.org/LICENSE_1_0.txt)
#include "icmp/icmpmessage.h"

//-----------------------------------------------------------------------------
// IcmpMessage
//-----------------------------------------------------------------------------

/**
 * @brief Default constructor.
 */
IcmpMessage::IcmpMessage()
{
}

/**
 * @brief Destructor.
 */
IcmpMessage::~IcmpMessage()
{
}

/**
 * This method MUST be called to initialize the data member of ICMP Messages.
 */
void IcmpMessage::init( const Icmpv4Type type )
{
    // Note: this code can not be placed in the constructor, because it calls
    // virtual function. If you call virtual functions from within a
    // constructor, the Base class version of methods will be called, not the
    // Derived class, because the Base is constructed before the Derived class.
    set_type_v4( type );
    set_code( 0 );
    set_checksum( 0 );
    set_identifier( 0 );
    set_sequence_number( 0 );
}

/**
 * This method MUST be called to initialize the data member of ICMP Messages.
 */
void IcmpMessage::init( const Icmpv6Type type )
{
    // Note: this code can not be placed in the constructor, because it calls
    // virtual function. If you call virtual functions from within a
    // constructor, the Base class version of methods will be called, not the
    // Derived class, because the Base is constructed before the Derived class.
    set_type_v6( type );
    set_code( 0 );
    set_checksum( 0 );
    set_identifier( 0 );
    set_sequence_number( 0 );
}
